## ros-lunar-diff-drive-controller 0.13.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(diff_drive_controller)

find_package(catkin REQUIRED COMPONENTS
    controller_interface
    dynamic_reconfigure
    nav_msgs
    realtime_tools
    tf
    urdf
)

generate_dynamic_reconfigure_options(cfg/DiffDriveController.cfg)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
)

include_directories(
  include
)

include_directories(SYSTEM
  ${catkin_INCLUDE_DIRS}
)

add_library(${PROJECT_NAME} src/diff_drive_controller.cpp src/odometry.cpp src/speed_limiter.cpp)
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES})
add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${PROJECT_NAME}_gencfg)

install(DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )

install(FILES diff_drive_controller_plugins.xml
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

if (CATKIN_ENABLE_TESTING)
  find_package(catkin REQUIRED COMPONENTS controller_manager rosgraph_msgs rostest std_srvs tf)
  include_directories(include ${catkin_INCLUDE_DIRS})

  add_executable(diffbot test/diffbot.cpp)
  target_link_libraries(diffbot ${catkin_LIBRARIES})

  add_executable(skidsteerbot test/skidsteerbot.cpp)
  target_link_libraries(skidsteerbot ${catkin_LIBRARIES})

  add_dependencies(tests diffbot skidsteerbot)

  add_rostest_gtest(diff_drive_test
    test/diff_drive_controller.test
    test/diff_drive_test.cpp)
  target_link_libraries(diff_drive_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_nan_test
    test/diff_drive_controller_nan.test
    test/diff_drive_nan_test.cpp)
  target_link_libraries(diff_drive_nan_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_limits_test
    test/diff_drive_controller_limits.test
    test/diff_drive_limits_test.cpp)
  target_link_libraries(diff_drive_limits_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_timeout_test
    test/diff_drive_timeout.test
    test/diff_drive_timeout_test.cpp)
  target_link_libraries(diff_drive_timeout_test ${catkin_LIBRARIES})
  add_rostest(test/diff_drive_multipliers.test)
  add_rostest(test/diff_drive_left_right_multipliers.test)
  add_rostest_gtest(diff_drive_fail_test
    test/diff_drive_wrong.test
    test/diff_drive_fail_test.cpp)
  target_link_libraries(diff_drive_fail_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_odom_tf_test
    test/diff_drive_odom_tf.test
    test/diff_drive_odom_tf_test.cpp)
  target_link_libraries(diff_drive_odom_tf_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_default_cmd_vel_out_test
    test/diff_drive_default_cmd_vel_out.test
    test/diff_drive_default_cmd_vel_out_test.cpp)
  target_link_libraries(diff_drive_default_cmd_vel_out_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_pub_cmd_vel_out_test
    test/diff_drive_pub_cmd_vel_out.test
    test/diff_drive_pub_cmd_vel_out_test.cpp)
  target_link_libraries(diff_drive_pub_cmd_vel_out_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_default_odom_frame_test
    test/diff_drive_default_odom_frame.test
    test/diff_drive_default_odom_frame_test.cpp)
  target_link_libraries(diff_drive_default_odom_frame_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_odom_frame_test
    test/diff_drive_odom_frame.test
    test/diff_drive_odom_frame_test.cpp)
  target_link_libraries(diff_drive_odom_frame_test ${catkin_LIBRARIES})
  add_rostest_gtest(diff_drive_multiple_cmd_vel_publishers_test
    test/diff_drive_multiple_cmd_vel_publishers.test
    test/diff_drive_multiple_cmd_vel_publishers_test.cpp)
  target_link_libraries(diff_drive_multiple_cmd_vel_publishers_test ${catkin_LIBRARIES})
  add_rostest(test/diff_drive_open_loop.test)
  add_rostest(test/skid_steer_controller.test)
  add_rostest(test/skid_steer_no_wheels.test)
  add_rostest(test/diff_drive_radius_sphere.test)
  add_rostest(test/diff_drive_radius_param.test)
  add_rostest(test/diff_drive_radius_param_fail.test)
  add_rostest(test/diff_drive_separation_param.test)
  add_rostest(test/diff_drive_bad_urdf.test)
  add_rostest_gtest(diff_drive_dyn_reconf_test
    test/diff_drive_dyn_reconf.test
    test/diff_drive_dyn_reconf_test.cpp)
  target_link_libraries(diff_drive_dyn_reconf_test ${catkin_LIBRARIES})
endif()

=== debian/changelog ===
ros-lunar-diff-drive-controller (0.13.4-0stretch) stretch; urgency=high

  * isPublishngCmdVelOut to check getNumPublisheres until timeout
  * Contributors: Kei Okada

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 25 Jun 2018 23:00:00 -0000

ros-lunar-diff-drive-controller (0.13.3-0stretch) stretch; urgency=high

  * add dynamic_reconf to diff_drive_controller
  * migrate to new pluginlib headers
  * typo in odometry.h
  * fix doc
  * per wheel radius multiplier
  * fix xacro macro warning
  * [DiffDrive] Test fixing (#318 <https://github.com/ros-controls/ros_controllers/issues/318>)
  * separate include_directories as SYSTEM to avoid unrelated compilation warnings
  * Contributors: Jeremie Deray, Mathias Lüdtke

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 26 Apr 2018 23:00:00 -0000

ros-lunar-diff-drive-controller (0.13.2-0stretch) stretch; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 23 Dec 2017 00:00:00 -0000

ros-lunar-diff-drive-controller (0.13.1-0stretch) stretch; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 06 Nov 2017 00:00:00 -0000

ros-lunar-diff-drive-controller (0.13.0-0stretch) stretch; urgency=high

  * Add test for allow_multiple_cmd_vel_publishers param
  * add check for multiple publishers on cmd_vel
  * Added tests for the odom_frame_id parameter.
  * Parameterized diff_drive_controller's odom_frame_id
  * Publish executed velocity if publish_cmd
  * refactor to remove code duplication
  * fixup pointer type for new convention
  * Allow diff_drive_controller to use spheres as well as cylinders for wheel collision geometry. Cylinders are not well behaved on Gazebo/ODE heightfields, using spheres works around the issue.
  * Contributors: Bence Magyar, Eric Tappan, Jeremie Deray, Karsten Knese, Tully Foote, mallanmba, tappan-at-git

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 09 Aug 2017 23:00:00 -0000

ros-lunar-diff-drive-controller (0.12.3-0stretch) stretch; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 22 Apr 2017 23:00:00 -0000

ros-lunar-diff-drive-controller (0.12.2-0stretch) stretch; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 20 Apr 2017 23:00:00 -0000

ros-lunar-diff-drive-controller (0.12.1-0stretch) stretch; urgency=high

  * Add exporting include dirs
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 08 Mar 2017 00:00:00 -0000

ros-lunar-diff-drive-controller (0.12.0-0stretch) stretch; urgency=high

  * Fix most catkin lint issues
  * Change for format2
  * Add Enrique and Bence to maintainers
  * Add urdf compatibility header
  * Add --inorder to xacro calls
  * Add missing xacro tags
  * Use xacro instead of xacro.py
  * Disable angular jerk limit test
  * Replace boost::shared_ptr<urdf::XY> with urdf::XYConstSharedPtr when exists
  * Contributors: Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 15 Feb 2017 00:00:00 -0000

ros-lunar-diff-drive-controller (0.11.2-0stretch) stretch; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 15 Aug 2016 23:00:00 -0000

ros-lunar-diff-drive-controller (0.11.1-0stretch) stretch; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 22 May 2016 23:00:00 -0000

ros-lunar-diff-drive-controller (0.11.0-0stretch) stretch; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 02 May 2016 23:00:00 -0000

ros-lunar-diff-drive-controller (0.10.0-0stretch) stretch; urgency=high

  * Address -Wunused-parameter warnings
  * Limit jerk
  * Add param velocity_rolling_window_size
  * Minor fixes
    1. Coding style
    2. Tolerance to fall-back to Runge-Kutta 2 integration
    3. Remove unused variables
  * Fix the following bugs in the testForward test:
    1. Check traveled distance in XY plane
    2. Use expected speed variable on test check
  * Add test for NaN
  * Add test for bad URDF
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Enrique Fernandez, Paul Mathieu

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 20 Nov 2015 00:00:00 -0000

ros-lunar-diff-drive-controller (0.9.2-0stretch) stretch; urgency=high

  * Allow the wheel separation and radius to be set from different sources
    i.e. one can be set from the URDF, the other from the parameter server.
    If wheel separation and wheel diameter is specified in the parameter server, don't look them up from urdf
  * Contributors: Bence Magyar, Nils Berg

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 03 May 2015 23:00:00 -0000

ros-lunar-diff-drive-controller (0.9.1-0stretch) stretch; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 03 Nov 2014 00:00:00 -0000

ros-lunar-diff-drive-controller (0.9.0-0stretch) stretch; urgency=high

  * Add support for multiple wheels per side
  * Odometry computation:
    - New option to compute in open loop fashion
    - New option to skip publishing odom frame to tf
  * Remove dependency on angles package
  * Buildsystem fixes
  * Contributors: Bence Magyar, Lukas Bulwahn, efernandez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 31 Oct 2014 00:00:00 -0000

ros-lunar-diff-drive-controller (0.8.1-0stretch) stretch; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 10 Jul 2014 23:00:00 -0000

ros-lunar-diff-drive-controller (0.8.0-0stretch) stretch; urgency=high

  * Add base_frame_id param (defaults to base_link)
    The nav_msgs/Odometry message specifies the child_frame_id field,
    which was previously not set.
    This commit creates a parameter to replace the previously hard-coded
    value of the child_frame_id of the published tf frame, and uses it
    in the odom message as well.
  * Contributors: enriquefernandez

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 11 May 2014 23:00:00 -0000

ros-lunar-diff-drive-controller (0.7.2-0stretch) stretch; urgency=high





=== debian/control ===
Source: ros-lunar-diff-drive-controller
Section: misc
Priority: extra
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-lunar-catkin, ros-lunar-controller-interface, ros-lunar-controller-manager, ros-lunar-dynamic-reconfigure, ros-lunar-nav-msgs, ros-lunar-realtime-tools, ros-lunar-rosgraph-msgs, ros-lunar-rostest, ros-lunar-std-srvs, ros-lunar-tf, ros-lunar-urdf, ros-lunar-xacro
Homepage: https://github.com/ros-controls/ros_controllers/wiki
Standards-Version: 3.9.2

Package: ros-lunar-diff-drive-controller
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-lunar-controller-interface, ros-lunar-dynamic-reconfigure, ros-lunar-nav-msgs, ros-lunar-realtime-tools, ros-lunar-tf, ros-lunar-urdf
Description: Controller for a differential drive mobile base.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-diff-drive-controller//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
